@rem = '-*- Perl -*-';
@rem = '
@echo off
bin\perl %0.cmd %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
';

#
# Perl script to make delivery of the NT perl product
#

#
# Global Variables
#
chop ($srcdir = `cd`);		# directory for source code
$templatedir = "$srcdir\\prod";	# Intergraph perl product template
$setup = "$srcdir\\setup32";	# directory for MS setup32
$delivdir = "c:\\tmp\\perl";	# directory where deliverable goes
$netdir = "$srcdir\\netprod";	# directory where public delivery goes
$Dsklay = -f "$srcdir\\dsklayt2.cmd" ? 
    "perl $srcdir\\dsklayt2.cmd" : "d:\\mstools\\mssetup\\disklay\\dsklayt2";

#
# packages required for this script
#
require "getopts.pl";
require 'ctime.pl';

#
# get options switches
#
#  -i - Intergraph delivery
#  -n - Network delivery
#  -a - All
#  -f - Full delivery (rebuild source)
#
#  default is -i
#

&Getopts('fina');
$opt_i = 1 if !defined($opt_f) && !defined($opt_a) &&
    !defined($opt_i) && !defined($opt_n);
$opt_a = 1 if $opt_f;
$opt_i = 1 if $opt_a;
$opt_n = 1 if $opt_a;

open (LOG, ">>mkdel.log") || die "Can't open mkdel.log for append: $!";

if ($opt_f) {
    print "Doing full build\n";
    print LOG  "\n", '-' x 72, "\nStarting make at ", &ctime(time);
    &make ("clean");
    &make ("NODEBUG=1");
    print LOG  "\n", '-' x 72, "\nFinished make at ", &ctime(time);
}

# make the writes unbuffered
$| = 1;

# put the local library at the head of the require search list
unshift (@INC, "$srcdir\\lib");

print LOG "\n", '-' x 72, "\nStarting delivery at ", &ctime(time);

$ENV{Path} = "$srcdir;$ENV{Path}";

#
# Do the work
#

&mkingrprod if $opt_i;

&mknetprod if $opt_n;

print "mkdel finished!\n";
print LOG "Finished delivery at ", &ctime(time);
exit 0;

#
# this subroutine does all the work for making a delivery
# for Intergraph
#

sub mkingrprod {
    print "Setting up for Intergraph delivery.";
    &obliterate($templatedir) if -d $templatedir;
    &obliterate($delivdir) if -d $delivdir;
    chdir ($srcdir);
    &cleansrc;			# clean up the source directory
    &verifyingrsrc;		# verify that everything is in place
    &mkingrdest;		# make destination directories
    &copyingrfiles;		# do the copy
    &verifyingrfiles;		# verify that they got there
    &cpsetup;			# copy the setup toolkit stuff
    &dolayout;			# do the MS setup stuff
    print "Intergraph delivery complete!\n";
}


#
# This subroutine makes the network delivery tree
#

sub mknetprod {
    local($netbin) = "$netdir\\bin";
    local($netsrc) = "$netdir\\src";
    local(@bindirs) = ("lib", "t", "eg", "nt");

    print "Making Network Release\n";
    if (-d $netdir) {
	print "  Removing old network tree";
	&obliterate($netdir);
	print "done\n";
    }
    print "  Making Network delivery trees\n";
    mkdir ($netdir, 0777) ||
	die "Can't create directory $netdir: $!\n";
    mkdir ($netbin, 0777) if ! -d $netbin;
    mkdir ($netsrc, 0777) if ! -d $netsrc;

    #
    # make the binary directory
    #

    print "  Copying binary release tree\n";
    &copy ("$srcdir\\perl.exe", $netbin) ||
	die "Copy of perl.exe to $netbin failed!\n";
    &copy ("$srcdir\\perlglob.exe", $netbin) ||
	die "Copy of perlglob.exe to $netbin failed!\n";
    &copy ("$srcdir\\readme.bin", $netbin) ||
	die "Copy of perlglob.exe to $netbin failed!\n";
    &copy ("$srcdir\\net\\*.cmd", $netbin) ||
	die "Copy of net\\*.cmd to $netbin failed!\n";
    foreach (@bindirs) {
	&copydir ("$srcdir\\$_", "$netbin\\$_") ||
	    die "Copy of $srcdir\\$_ to $netbin\\$_ failed!\n";
    }
    &cleannt("$netbin\\nt");

    #
    # make the source directory
    #

    print "  Copying source release tree\n";
    &copy ("$srcdir\\*.c", $netsrc) ||
	die "Copy of *.c to $netsrc failed!\n";
    &copy ("$srcdir\\*.h", $netsrc) ||
	die "Copy of *.h to $netsrc failed!\n";
    &copy ("$srcdir\\*.y", $netsrc) ||
	die "Copy of *.y to $netsrc failed!\n";
    &copy ("$srcdir\\*.cmd", $netsrc) ||
	die "Copy of *.cmd to $netsrc failed!\n";
    &copy ("$srcdir\\readme", $netsrc) ||
	die "Copy of readme to $netsrc failed!\n";
    &copy ("$srcdir\\read.me", $netsrc) ||
	die "Copy of read.me to $netsrc failed!\n";
    &copy ("$srcdir\\net\\readme.src", "$netsrc\\readme.nt") ||
	die "Copy of $srcdir\\net\\readme.src to $netsrc failed!\n";
    &copy ("$srcdir\\net\\makefile", $netsrc) ||
	die "Copy of $srcdir\\net\\makefile to $netsrc failed!\n";
    &copy ("$srcdir\\net\\*.cmd", $netsrc) ||
	die "Copy of $srcdir\\net\\*.cmd to $netsrc failed!\n";
    foreach (@bindirs) {
	&copydir ("$srcdir\\$_", "$netsrc\\$_") ||
	    die "Copy of $srcdir\\$_ to $netsrc\\$_ failed!\n";
    }
    &cleannt("$netsrc\\nt");

    #
    # make the zip files
    #

    chdir ($netbin);
    print "  making binary zip file\n";
    &zip ("-rq", "$netdir\\ntperlb.zip", ".");
    chdir ($netsrc);
    print "  making sources zip file\n";
    &zip ("-rq", "$netdir\\neperls.zip", ".");
    print "Network Delivery Complete\n";
    chdir ($srcdir);
}

sub cleannt {
    local($ntdir) = @_;
    opendir (D, $ntdir) || die "cleannt: can't open directory $ntdir: $!\n";
    grep (-f "$ntdir\\$_" && !/[.]txt$/ && unlink ("$ntdir\\$_") && 0, readdir(D));
    closedir(D);
}

sub obliterate {
    local($path) = @_;
    local(@files);
    print ".";
    die "obliterate called with non-directory argument ($path)\n"
	if ! -d $path;
    opendir(D, $path) || die "Can't open directory $path: $!\n";
    @files = grep (!/^\.$/ && !/^\.\.$/ && ($_ = "$path\\$_"), readdir(D));
    closedir(D);
    @dirs = grep (do {unlink if -f $_; (-d $_) ? &obliterate($_) : 0}, @files);
    rmdir $path ||
	die "can't delete $path: $!\n";
}

sub cleansrc {
    local(@badfiles);
    print ".";
    &nuketilde("$srcdir\\lib");
    &nuketilde("$srcdir\\t");
    unlink("$srcdir\\t\\perlglob.exe") if -e "$srcdir\\t\\perlglob.exe";
    unlink("$srcdir\\t\\perl.exe") if -e "$srcdir\\t\\perl.exe"
}

sub nuketilde {
    local($dir) = @_;
    local(@files);

    die "&nuketilde passed non-directory argument: $dir\n" if ! -d $dir;
    print ".";
    opendir(D, $dir) || die "Can't open directory $dir: $!\n";
    @files = grep (!/^\.$/ && !/^\.\.$/ && ($_ = "$dir\\$_"), readdir(D));
    closedir(D);
    grep (do {unlink if /~/ && -f; &nuketilde($_) if -d; 0;}, @files);
}

#
# This routine verifys that the source files are in the correct places
#

sub verifyingrsrc {
    local(@dirs) = ('t', 'lib', 'nt', 'eg');
    local(@files) = ('perl.exe', 'perlglob.exe', 'nt\\readme.txt',
		     'nt\\status.txt', 'nt\\relnotes.txt', 
		     'nt\\manifest.txt', 'nt\\registry.txt', 
		     'eg\\find83.cmd', 'eg\\ntcvt.cmd', 
		     'eg\\status.cmd', 'doc\\perlhp.hlp');

    print ".";
    grep (do{die "source directory $_ not found\n" if ! -d;}, @dirs);
    grep (do{die "source file $_ not found\n" if ! -e;}, @files);
}

#
# This routine checks for the existance of the target directories and
# makes them if required
#

sub mkingrdest {
    local(@dirs) = ('t', 'lib', 'bin', 'eg');

    print ".";
    if (! -d $templatedir) {
	mkdir ($templatedir, 0777) || die "can't create $templatedir: $!\n";
    }
    foreach (@dirs) {
	if (! -d "$templatedir\\$_") {
	    mkdir ("$templatedir\\$_", 0777) 
		|| die "can't create $templatedir\\$_: $!\n";
	}
    }
}

#
# This routine copies all the files that comprise the perl delivery
# for NT to the appropriate directories.
#

sub copyingrfiles {
    local(@exe) = ('perl.exe', 'perlglob.exe');
    local(@doc) = ('nt\\manifest.txt', 'nt\\status.txt', 'nt\\relnotes.txt',
		   'nt\\readme.txt', 'nt\\registry.txt', 'doc\\perlhp.hlp',
		   'nt\\regupdat.cmd', 'nt\\uninstal.cmd');
    local(@dir) = ('lib', 'eg');
    print "done\nInstallation template directory is $templatedir\n";

    #
    # First copy the executables
    #

    print "Copying executables: ";
    foreach $exe (@exe) {
	print "$exe ";
	&copy ($exe, "$templatedir\\bin")
	    || die "\ncan't copy $exe to $templatedir\\bin: $!\n";
    }

    #
    # Now copy the documentation
    #

    print "\nCopying documentation: ";
    foreach $doc (@doc) {
	($targ = $doc) =~ s|^nt\\||;
	print "$targ ";
	&copy ($doc, $templatedir) ||
	    die "can't copy $targ to $templatedir: $!\n";
    }

    #
    # Now get the directories
    #

    print "\nCopying directories: ";
    foreach $dir (@dir) {
	print "$dir ";
	&copydir ("$srcdir\\$dir", "$templatedir\\$dir")
	    || die "can't copy directory $dir to $templatedir\\$dir: $!\n";
    }
    print "\n";
}

sub verifyingrfiles {
    local(@manifest);
    local(@files);

    open (M, "nt\\manifest.txt") || die "can't open manifest.txt: $!";
    do {$junk = <M>;} until ($junk =~ /^\s*$/);
    @manifest = <M>;
    close M;
    
    @files=();
    foreach (@manifest) {
	chop;
	next if /(^\s*$)|(^\s+)/;
	s/^(\S+).*$/$1/;
	push (@files, $_);
    }
    foreach $file (@files) {
	die "$templatedir\\$file not copied!" if ! -e "$templatedir\\$file";
    }	    
}


sub cpsetup {
    print "Copying setup tools to $templatedir\n";
    &copy ("$setup\\setup.*", $templatedir);
    &copy ("$setup\\*.dll",  $templatedir);
    &copy ("$setup\\perldel.lyt", $templatedir);
    &copy ("$setup\\perldel.exe", $templatedir);
    &copy ("$setup\\perldel.inf", $templatedir);
}


sub old_dolayout {
    print "running mssetup disk layout tool\n";
    chdir "$templatedir";
    system "$Dsklay perldel.lyt perldel.inf /f /kN /d $delivdir";
    system "expand $delivdir\\perldel.in_ $delivdir\\perldel.inf";
}

sub dolayout {
    print "running perl clone of mssetup disk layout tool\n";
    chdir "$templatedir";
    system "$Dsklay perldel.lyt perldel.inf -f -kN -d $delivdir";
}

sub copy {
    local ($src, $dst) = @_;
    system "copy $src $dst >nul:";
    $? >> 8 ? 0 : 1;
}

sub copydir {
    local ($src, $dst) = @_;
    local ($cmd) = "xcopy $src $dst /q/e/v/r/i >nul:";
    system $cmd;
    $? >> 8 ? 0 : 1;
}

sub make {
    local ($targstring) = @_;
    local ($cmd) = "nmake -nologo $targstring";
    print "\t$cmd\n";
    system "$cmd";
    $? >> 8 ? 0 : 1;
}

sub zip {
    local ($opts, $zipfile, $elements) = @_;
    local ($cmd) = "zip $opts $zipfile $elements";
    system $cmd;
    $? >> 8 ? 0 : 1;
}

#
# Don't delete this! It's part of the NT script magic.
#
__END__
:endofperl
